
/**
 * @author Ian Johnson
 * @version 1.0
 */


#ifndef SLSQT2DZOOMER_H
#define SLSQT2DZOOMER_H


#include <qwt_plot_zoomer.h>
#include <qwt_plot_panner.h>

#include "SlsQt2DHist.h"

class SlsQt2DZoomer:public QwtPlotZoomer{
 private:
  SlsQt2DHist* hist;

 public:
  SlsQt2DZoomer(QwtPlotCanvas *canvas):QwtPlotZoomer(canvas){
    setTrackerMode(AlwaysOn);
  }

  void SetHist(SlsQt2DHist* h){
    hist=h;
  }
  
  virtual QwtText trackerText(const QwtDoublePoint &pos) const{
    QColor bg(Qt::white);
#if QT_VERSION >= 0x040300
    bg.setAlpha(200);
#endif

    
    //QwtText text = QwtPlotZoomer::trackerText(pos);

    static QwtText text; 
    if(hist){
      static char t[200];
      sprintf(t,"%3.2f, %3.2f, %3.2f",pos.x(),pos.y(),hist->value(pos.x(),pos.y()));
      text.setText(t);
    }else  text = QwtPlotZoomer::trackerText(pos);

    text.setBackgroundBrush( QBrush( bg ));
    return text;
  }
};

#endif
